﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System.Collections.Generic;
using HeuristicLab.Core;

namespace HeuristicLab.DataPreprocessing.Interfaces {

  public interface IPreprocessingData : INamedItem {
    T GetCell<T>(int columnIndex, int rowIndex);
    void SetCell<T>(int columnIndex, int rowIndex, T value);

    IList<T> GetValues<T>(int columnIndex);
    void SetValues<T>(int columnIndex, IEnumerable<T> values);

    void InsertRow(int rowIndex);
    void DeleteRow(int rowIndex);

    void InsertColumn(string variableName, int columnIndex);
    void DeleteColumn(int columnIndex);

    IList<string> VariableNames { get; }
    bool IsType<T>(int columnIndex);

    int Columns { get; }
    int Rows { get; }
  }
}
